abuild.in 22.1 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
apkcache=@apkcache@
Natanael Copa's avatar
Natanael Copa committed
14 15 16

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
17
pkgbasedir=${pkgbasedir:-"$startdir/pkg"}
Natanael Copa's avatar
Natanael Copa committed
18
pkgrel=0
Natanael Copa's avatar
Natanael Copa committed
19 20
repo=${startdir%/*}
repo=${repo##*/}
Natanael Copa's avatar
Natanael Copa committed
21 22 23 24

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}
25
BUILD_BASE="build-base"
Natanael Copa's avatar
Natanael Copa committed
26

27 28
SUDO=${SUDO:-"sudo"}

29
default_cmds="sanitycheck builddeps clean fetch unpack rootpkg apkcache"
Natanael Copa's avatar
Natanael Copa committed
30

Natanael Copa's avatar
Natanael Copa committed
31
# read config
Natanael Copa's avatar
Natanael Copa committed
32
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
33 34
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

35
# source functions
36 37
datadir=/usr/share/abuild

Natanael Copa's avatar
Natanael Copa committed
38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69
#colors
if [ -n "$USE_COLORS" ]; then
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
70 71

	
Linux User's avatar
Linux User committed
72 73
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
74
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
75 76 77 78 79
	fi
} 

cleanup() {
	set_xterm_title ""
80
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
81
		$SUDO apk del $uninstall_after
82
	fi
Linux User's avatar
Linux User committed
83 84
}

Natanael Copa's avatar
Natanael Copa committed
85
die() {
Linux User's avatar
Linux User committed
86
	error "$@"
Linux User's avatar
Linux User committed
87
	cleanup
Natanael Copa's avatar
Natanael Copa committed
88 89 90
	exit 1
}

91 92
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
93
	local i
94
	msg "Checking sanity of $APKBUILD..."
95 96 97
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
98
	[  "${pkgver##[0-9]}" == "$pkgver" ] && \
99 100 101 102 103 104
		die "pkgver does not start with a digit"
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

105 106 107
	if [ -n "$source" ]; then
		for i in $source; do
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
108 109 110
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
111 112
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
113

114 115 116 117 118
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
			source_has $i || die "$i is missing in source"
		done
	fi
119

120 121 122
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
123 124

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
125 126

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
127 128 129 130
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
131
	local dummy f
132 133 134
	if [ -z "$source" ]; then
		return 0
	fi
135
	if [ -z "$md5sums" ]; then
136
		die "Use 'abuild checksum' to generate/update the checksum(s)"
137
	fi
138 139 140
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
141
	fetch || return 1
142
	msg "Checking md5sums..."
143
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
144 145 146 147 148
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
149 150 151 152
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

153 154 155 156 157 158
	
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
159
	mkdir -p "$SRCDEST"
160 161 162
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
163
	fi
Linux User's avatar
Linux User committed
164
	msg "Fetching $uri"
165 166
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
167 168
}

169 170
is_remote() {
	case "$1" in
171
		http://*|ftp://*|https://*)
172 173 174 175 176
			return 0;;
	esac
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
177 178 179
fetch() {
	local s
	mkdir -p "$srcdir"
180 181 182 183 184 185 186
	for s in $source; do
		if is_remote "$s"; then
			uri_fetch "$s" || return 1
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
187 188 189 190 191 192
	done
}

# unpack the sources
unpack() {
	local u
193
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
194 195 196 197
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
198
			*.tar.gz|*.tgz)
199
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
200 201
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
202
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
203
				tar -C "$srcdir" -jxf "$s" || return 1;;
204 205 206 207
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
208 209 210
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
211 212 213 214 215 216
		esac
	done
}

# cleanup source and package dir
clean() {
217
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
218
	rm -rf "$srcdir"
219
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
220 221 222 223 224 225
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
226 227 228 229
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
230 231 232 233 234
	done
}

cleanpkg() {
	local i
235
	msg "Cleaning built packages..."
236
	for i in $pkgname $subpackages; do
237 238
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
239
			"$apkcache"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
240
	done
241 242
	# remove given packages from index

Natanael Copa's avatar
Natanael Copa committed
243 244
}

245 246 247 248 249 250 251 252 253 254 255 256 257
# clean all packages except current
cleanoldpkg() {
	local i j
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
	
Natanael Copa's avatar
Natanael Copa committed
258 259
runpart() {
	local part=$1
260
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
261 262 263 264 265 266 267 268
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

269 270 271 272 273 274 275 276 277
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

278
prepare_subpackages() {
279
	if [ -z "$subpackages" ]; then
280 281
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
282 283
	local i
	cd "$startdir"
284
	for i in $subpackages; do
285 286
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
287
		msg "Running split function $func..."
288
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
289
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
290 291 292
	done
}

293
prepare_metafiles() {
294 295
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
296
	local dir=${subpkgdir:-$pkgdir}
297
	local pkg="$name-$pkgver-r$pkgrel.apk"
298
	local sub
Natanael Copa's avatar
Natanael Copa committed
299 300 301 302 303 304
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

305
	echo "# Generated by $(basename $0) $abuild_ver" >.PKGINFO
Natanael Copa's avatar
Natanael Copa committed
306 307 308 309 310
	if [ -n "$FAKEROOTKEY" ]; then
		echo "# using $(fakeroot -v)" >> .PKGINFO
	fi
	echo "# $(date -u)" >> .PKGINFO
	cat >> .PKGINFO <<EOF
311
pkgname = $name
312
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
313 314 315 316 317 318
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
319 320
	local i deps
	deps="$depends"
321 322 323 324 325 326 327 328
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
		for i in $install; do
			if head -n 1 "$srcdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
329 330
	fi
	
Natanael Copa's avatar
Natanael Copa committed
331 332 333 334 335 336
	for i in $license; do
		echo "license = $i" >>.PKGINFO
	done
	for i in $replaces; do
		echo "replaces = $i" >>.PKGINFO
	done
337
	for i in $deps; do
Natanael Copa's avatar
Natanael Copa committed
338 339 340 341 342 343 344 345 346 347 348 349 350
		echo "depend = $i" >>.PKGINFO
	done
	for i in $conflicts; do
		echo "conflict = $i" >>.PKGINFO
	done
	for i in $provides; do
		echo "provides = $i" >>.PKGINFO
	done
	for i in $backup; do
		echo "backup = $i" >>.PKGINFO
	done

	local metafiles=".PKGINFO"
351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368
	for i in $install; do
		script=${i#$name}
		case "$script" in
			.install)
				warning "Deprecated .install script found."
				script=.INSTALL
				;;
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall)
				msg "Adding $script"
				;;
			*) 	error "$script: Invalid install script"
				return 1
				;;
		esac
		cp "$srcdir/$i" "$dir/$script" || return 1
		chmod +x "$dir/$script"
		metafiles="$metafiles $script"
	done
369
	echo $metafiles | tr ' ' '\n' > "$dir"/.metafiles
370
}
371

372 373 374
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
375
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' >"$dir"/.provides-so
376 377 378 379 380 381 382
	scanelf -Rn "$dir" | awk '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
		grep "^$i$" "$dir"/.provides-so >/dev/null \
			|| echo $i >> "$dir"/.needs-so
	done
Natanael Copa's avatar
Natanael Copa committed
383 384
}

385
prepare_package() {
386
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
387
	stripbin
388
	prepare_metafiles
389
	prepare_tracedeps
390 391 392 393 394 395 396 397
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

398 399 400
trace_apk_deps() {
	local name="$1"
	local dir="$2"
401 402
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
403
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
404
		found=
405
		# first check if its provide by same apkbuild
406 407
		for j in "$dir"/../*/.provides-so; do
			grep -w "$i" "$j" >/dev/null || continue
408 409
			found=${j%/.provides-so}
			found=${found##*/}
410
			break
411 412 413 414 415 416 417 418 419 420 421 422 423
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
			found=$(apk info -q -W /lib/$i /usr/lib/$i)
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
		if grep -w "^depend = $found" "$dir"/.PKGINFO >/dev/null ; then
			warning "You can remove '$found' from depends"
			continue
		fi
424 425
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
426 427 428 429 430 431 432 433
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

434 435
create_apks() {
	local file
436
	for file in "$pkgbasedir"/*/.PKGINFO; do
437 438 439
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
440
		local apk=$name-$ver.apk
441 442

		trace_apk_deps "$name" "$dir" || return 1
443
		msg "Creating $apk..."
444
		(
445
		cd "$dir"
446 447
		set *
		[ "$1" = '*' ] && set --
448
		tar -zcf "$PKGDEST"/$apk $(cat .metafiles) $@
449 450
		)
	done
Natanael Copa's avatar
Natanael Copa committed
451 452
}

453 454
update_apkcache_index() {
	local index="$apkcache"/APK_INDEX.gz
455 456 457 458 459 460 461 462 463 464
	local opt=
	(
	for i in "$@"; do
		pkg=${i##*/}
		todelete="$todelete ${pkg%-[0-9]*.apk}"
	done
	if [ -f "$index" ]; then
		apk index -q -d "$index" $todelete || exit 1
	fi
	apk index -q "$@" || exit 1
465 466
	) > "$apkcache"/APK_INDEX.new || return 1
	gzip "$apkcache"/APK_INDEX.new && mv "$apkcache/APK_INDEX.new.gz" "$index"
467 468
}

469
apkcache() {
470 471 472 473
	if ! up2date; then
		sanitycheck && builddeps && clean && fetch && unpack && rootpkg || return 1
	fi
	local apk
474
	set --
475
	for apk in $(listpkg); do
476 477
		ln -sf "$PKGDEST"/$apk "$apkcache"/$apk
		set -- "$@" "$apkcache"/$apk
478 479
	done

480
	# update the apkcache cache here
481
	msg "Updating the cached abuild repository index..."
482
	update_apkcache_index "$@"
483 484
}

485
# predefined splitfunc doc
486
default_doc() {
487
	depends="$depends_doc"
488
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
489
	local i
490
	for i in doc man info html sgml licenses gtk-doc; do
491 492 493
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
494 495
		fi
	done
496 497 498
	
	rm -f "$subpkgdir/usr/share/info/dir"

499 500 501
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
502 503 504 505

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
506
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
507 508 509
	return 0
}

510 511 512 513
doc() {
	default_doc
}

514
# predefined splitfunc mod
515
default_mod() {
516
	depends="$kernel $depends_mod"
517
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
518
	for i in firmware modules; do
519 520 521
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
522
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
523 524 525 526
		fi
	done
}

527 528 529 530
mod() {
	default_mod
}

531
# predefined splitfunc dev
532
default_dev() {
533
	depends="$pkgname $depends_dev"
534
	install="$install_dev"
535
	cd "$pkgdir" || return 0
536 537 538 539 540
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
541 542
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
543
			mkdir -p "$d"
544
			mv "$pkgdir/$i" "$d"
545
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
546 547
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
548
	return 0
Natanael Copa's avatar
Natanael Copa committed
549 550
}

551 552 553 554
dev() {
	default_dev
}

Natanael Copa's avatar
Natanael Copa committed
555 556
# build and package in fakeroot
rootpkg() {
Natanael Copa's avatar
Natanael Copa committed
557
	cd "$startdir"
558
	msg "Entering fakeroot..."
559
	fakeroot $0 build prepare_subpackages prepare_package create_apks
Natanael Copa's avatar
Natanael Copa committed
560 561 562
}

srcpkg() {
563
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
564
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
565 566 567 568 569
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
570
	msg "Creating source package $p.src.tar.gz..."
571
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
572 573
}

574 575
# check if package is up to date
up2date() {
576
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
577
	local i s
Natanael Copa's avatar
Natanael Copa committed
578
	cd "$startdir"
579 580 581 582 583
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

584
	for i in $source APKBUILD; do
585 586 587 588 589 590
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
591 592 593 594 595 596 597
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

598 599 600 601 602 603 604 605 606 607 608 609 610
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/../..)
	for i in $aportsdir/*/*/APKBUILD; do
		pkgname=
		subpackages=
		depends=
		makedepends=
611
		. $i
612
		dir=${i%/APKBUILD}
613 614 615 616 617 618 619 620
		deps=
		# filter out conflicts from deps
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
			deps="$deps $j"
		done
621
		for j in $pkgname $subpackages; do
622
			echo "o ${j%%:*} $dir"
623
			set -- $deps
624 625 626 627 628 629 630
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
631 632
		done
	done
633
	)
634 635
}

636
deptrace() {
637 638
	local deps="$@"
	[ -z "$deps" ] && deps="$BUILD_BASE $depends $makedepends"
639 640 641
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
Natanael Copa's avatar
Natanael Copa committed
642
			apk info -q | sort |  sed 's/^/i /'
643
		fi
644
	) | awk -v pkgs="$deps" '
645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
670 671
	local deps alldeps pkg i dir ver missing installed_deps
	msg "Analyzing dependencies..."
672 673
	deps="$BUILD_BASE $makedepends"

674

675 676 677 678 679
	# add depends unless it is a subpackage
	for i in $depends; do
		subpackages_has $i || deps="$deps $i"
	done

680
	installed_deps=$(apk info -e $deps)
681
	# find which deps are missing
682
	for i in $deps; do
683
		if [ "${i#\!}" != "$i" ]; then
684
			list_has ${i#\!} $installed_deps \
685
				&& die "Conflicting package ${i#\!} is installed."
686
		elif ! list_has $i $installed_deps; then
687 688 689 690 691 692 693
			if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
				die "Missing dependency $i. Use -r to autoinstall or -R to build"
			fi
			missing="$missing $i"
		fi
	done

694 695
	[ -z "$missing" ] && [ -z "$install_deps" ] && [ -z "$recursive" ] \
		&& return 0
696

697 698
	uninstall_after=".makedepends-$pkgname $uninstall_after"
	if [ -n "$install_deps" ]; then
699
		$SUDO apk add --repo "$apkcache" \
700 701
			--virtual .makedepends-$pkgname $deps \
			&& return 0
702
	fi
703 704 705 706
	
	[ -z "$recursive" ] && return 1
	
	for i in $(deptrace $missing); do
707 708 709 710
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
		msg "Entering $dir"
711
		cd "$dir" && $0 -k -r apkcache || return 1
712
	done
713
	$SUDO apk add --repo "$apkcache" \
714
		--virtual .makedepends-$pkgname $deps
715 716
}

717
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
718 719
checksum() {
	local s files
720
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
721
	fetch
722
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
723 724 725 726
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
727 728
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
729 730
}

731
stripbin() {
732
	local bin
733
	options_has "!strip" && return 0
734 735
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
736
	find . -type f 2>/dev/null | while read bin; do
737 738 739 740 741 742 743 744 745 746 747
		local opt=
		case "$(file -biz "$bin")" in
			*/x-sharedlib*|*/x-archive*)
				strip --strip-debug "$bin";;
			*/x-executable*)
				strip "$bin";;
		esac
	done
	return 0
}

748 749 750 751 752 753 754 755
# simply list target apks
listpkg() {
	local i 
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
756 757 758 759 760 761 762 763
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
764 765 766 767 768 769 770 771
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

772 773 774 775 776 777 778 779 780 781 782 783 784 785 786
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

options_has() {
	list_has "$1" $options
}

787 788 789 790
depends_has() {
	list_has "$1" $depends
}

791 792 793 794
makedepends_has() {
	list_has "$1" $makedepends
}

Natanael Copa's avatar
Natanael Copa committed
795 796 797 798
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
799 800 801 802 803 804 805 806 807 808 809 810 811 812
# install package after build
post_add() {
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
	deps=$(apk index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
813
	$SUDO apk add -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
Natanael Copa committed
814 815
}

816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831 832 833 834 835 836 837 838
# create new aport from templates
newaport() {
	local pn=${newname%-[0-9]*}
	local pv
	if [ "$pn" != "$newname" ]; then
		pv=${newname#$pn-}
	fi
	if [ -e "$pn"/APKBUILD ]; then
		error "$pn/APKBUILD already exist"
		return 1
	fi
	mkdir -p "$pn"
	cd "$pn"
	sed 	-e '1,/^\#*$/d' \
		-e "s/^\(# Contributor: \).*/\1$PACKAGER/" \
		-e "s/^\(# Maintainer: \).*/\1$PACKAGER/" \
		-e "s/^pkgname=.*/pkgname=$pn/" \
		-e "s/^pkgver=.*/pkgver=$pv/" \
		"$datadir"/sample.APKBUILD > APKBUILD || return 1
	#-e '1,/^\#$/d' \
	if [ -n "$cpinitd" ]; then
		cp "$datadir"/sample.initd $pn.initd
		cp "$datadir"/sample.confd $pn.confd
839 840 841
		cp "$datadir"/sample.pre-install $pn.pre-install
		cp "$datadir"/sample.post-install $pn.post-install
		sed -i -e "s/^install=.*/install=\"\$pkgname.pre-install \$pkgname.post-install\"/" \
842 843 844 845 846
			-e "s/^source=\"\(.*\)\"/source=\"\1\n\t$pn.initd\n\t$pn.confd\n\t\$install\n\t\"/" \
			APKBUILD
		
	fi
}
847 848

installdeps() {
849
	local deps i
850
	sudo apk add --repo "$apkcache" --virtual .makedepends-$pkgname \
851
		$makedepends
852 853 854
}

uninstalldeps (){
855
	sudo apk del .makedepends-$pkgname
856
}
857
	
Natanael Copa's avatar
Natanael Copa committed
858
usage() {
859
	echo "$(basename $0) $abuild_ver"
860 861
	echo "usage: ${0##*/} [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
	echo "              [-s SRCDEST] [cmd] ..."
862
	echo "       ${0##*/} [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
863 864
	echo "Options:"
	echo " -f  Force specified cmd, even if they are already done"
865 866
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
867
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
868
	echo " -p  Set package destination directory"
869
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
870
	echo " -q  Quiet"
871 872
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
873
	echo " -s  Set source package destination directory"
874
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
875
	echo ""
876 877 878
	echo " -n  Create a new APKBUILD in a directory named PKGNAME"
	echo " -c  Copy a sample init.d, conf.d and install script to new directory"
	echo ""
Natanael Copa's avatar
Natanael Copa committed
879
	echo "Commands:"
880
	echo "  checksum    Generate checksum to be included in APKBUILD"
881 882 883 884 885
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
886
	echo "  listpkg     List target packages"
887 888 889
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
890
	echo "  cleanoldpkg Remove binary packages except current version"
891 892 893 894
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
895 896
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
897 898 899 900 901
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
902 903
unset force
unset recursive
904
while getopts "cfhi:kin:p:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
905
	case $opt in
906
		'c') cpinitd=1;;
Natanael Copa's avatar
Natanael Copa committed
907
		'f') force=1;;
908 909
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
910
		'k') keep=1;;
911
		'n') newname=$OPTARG;;
912
		'p') PKGDEST=$OPTARG;;
913
		'P') REPODEST=$OPTARG;;
Natanael Copa's avatar
Natanael Copa committed
914
		'q') quiet=1;;
915 916
		'r') install_deps=1;;
		'R') recursive=1;;
917
		's') SRCDEST=$OPTARG;;
918 919
		'u') upgrade=1
		     recursive=1;;
Natanael Copa's avatar
Natanael Copa committed
920 921 922 923
	esac
done
shift $(( $OPTIND - 1 ))

924 925 926 927 928
# If REPODEST is set then it will override the PKGDEST
if [ -n "$REPODEST" ]; then
	PKGDEST="$REPODEST/$repo"
fi

929
# source the buildfile
930 931 932 933
if [ -z "$newname" ]; then
	[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
	. "$APKBUILD"
fi
934

935
# If we are handling a sub package then reset subpackages and install
936 937
if [ -n "$subpkgname" ]; then
	subpackages=
938
	install=
939
fi
940
pkgdir="$pkgbasedir/$pkgname"
Natanael Copa's avatar
Natanael Copa committed
941 942

trap 'die "Aborted by user"' INT
Linux User's avatar
Linux User committed
943
set_xterm_title "abuild: $pkgname"
Natanael Copa's avatar
Natanael Copa committed
944

945 946 947
if [ -z "$1" ] && [ -n "$newname" ]; then
	set "newaport"
fi
Natanael Copa's avatar
Natanael Copa committed
948 949

if [ -z "$1" ]; then
Natanael Copa's avatar
Natanael Copa committed
950
	if up2date && [ -z "$force" ]; then
Natanael Copa's avatar
Natanael Copa committed
951
		msg "Package is up to date"
952 953 954
	else
		set $default_cmds
	fi
Natanael Copa's avatar
Natanael Copa committed
955 956 957 958 959 960
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done
961 962

for i in $install_after; do
Natanael Copa's avatar
Natanael Copa committed
963
	post_add $i
964 965
done

Linux User's avatar
Linux User committed
966
cleanup
Natanael Copa's avatar
Natanael Copa committed
967